// Country6a.h
// This will hold the class definitions for countries
// Copyright (c) 1998 Forest J. Handford
/////////////////////////////////////////////////////

#ifndef Country6a_h
#define Country6a_h

#include <string.h>
#include <stdlib.h>

#define TRUE 1
#define FALSE 0

int Total = 1;        // A global count of the total players
int AddArmies = 5;    // A global count of the number of armies to win after a kill


class CCountries
{
    class CPlayer
    {

        friend CCountries;

    private:

        CPlayer    *Link;
        CPlayer *Previous;
        int Armies;
        int Money;
        int Territory;
        int Technology;
        int UpgradeCost;
        char Name[15];

        // This will check for to many territories
        void CountryLoss()
        {
            if(Armies < Territory)
            {
                cout<<"Sorry "<<Name<<", you don't have enough armies to keep "
                    <<"your territories!  They are"
                    <<endl<<"reduced to "<<Armies<<"."
                    <<endl;
                Territory = Armies;
            }
        }


    public:

        int ShowArmies()
        {
            return (Armies);
        }

        // This writes the name of the given player
        ///////////////////////////////////////////
        void WriteName()
        {
            cout<<Name;
        }

        // This will sell land to the player
        ////////////////////////////////////
        void Grow()
        {
            char YorN = 'y';    // For Yes or No answers

            // Loop as long as they want to grow
            for(int Count=0; tolower(YorN) == 'y'; Count++)
            {
                // They must have at least one army for every territory
                if (Armies <= Territory)
                {
                    cout<<"You need more armies for more land."<<endl;
                    break;
                }
                // Sell the land and tell the players
                else if(Money > 0)
                {
                    Money -= 1;
                    Territory += 1;
                    cout<<"You now have "<<Territory
                        <<" States and "<<Money<<" money."<<endl;
                    // Don't stay here if they are out of land or money
                    if((Armies <= Territory) || (Money <= 0))
                    {
                        break;
                    }
                    cout<<"Would you like to buy another ((Y)es or (N)o)? ";
                    cin>>YorN;
                }
                // If they are out of money tell them and exit
                else
                {
                    cout<<"You are out of money!"<<endl;
                    break;
                }
            }

        }

        // This will sell upgrades
        //////////////////////////
        void Upgrade()
        {
            char YorN = 'y';

            // Loop till the user is out of money or is bored
            while(tolower(YorN) == 'y')
            {
                // Take their money if they have any
                if(Money >= UpgradeCost)
                {
                    Money -= UpgradeCost;
                    UpgradeCost *= 2;
                    Technology += 1;
                    cout<<"You now have "<<Technology
                        <<" Upgrades and "<<Money<<" money."<<endl;
                    cout<<"Upgrades now cost you : "<<UpgradeCost<<"."<<endl;
                }
                else    // Scold them for having no money
                {
                    cout<<"You don't have enough money.  You need "<<UpgradeCost<<"."
                        <<endl;
                }
                // break if they run out of money
                if(Money <= UpgradeCost)
                {
                    break;
                }

                // ask if they want more
                cout<<"Would you like to upgrade again ((Y)es or (N)o)? ";
                cin>>YorN;
            }
        }

        // This will sell land back
        ///////////////////////////
        void Shrink()
        {
            char YorN = 'y';

            while(tolower(YorN) == 'y')
            {
                if(Territory > 0)
                {
                    Money += 1;
                    Territory -= 1;
                    cout<<"You now have "<<Territory
                        <<" States and "<<Money<<" money."<<endl;
                    cout<<"Would you like to sell another ((Y)es or (N)o)? ";
                    cin>>YorN;
                }
                else
                {
                    cout<<"You are out of money!"<<endl;
                    break;
                }
            }
        }

        // This adds stuff for the player
        /////////////////////////////////
        void AddStuff()
        {
            Armies += Territory;
            Money += Territory;
            cout<<Name<<" now has "<<Armies
                <<" armies and "<<Money<<" money from ";
            cout<<Name<<"'s states."<<endl<<endl;
        }

    };

private:

    CPlayer *Rear;

public:    

    CPlayer *Front;

    //Set the Front and rear to point to 0
    //////////////////////////////////////
    CCountries()
    {
        Front = 0;    //make front null
        Rear = 0;    //make rear null

        char Exit = 'N';    // Y or N value

        AddPlayer(Total);
        
        while(toupper(Exit) != 'Y')
        {
            Total++;
            AddPlayer(Total);
            cout<<"Are you the last player ((Y)es or (N)o)? ";
            cin>>Exit;
        }
    }

    //The destructor that deletes any nodes on the queue
    ////////////////////////////////////////////////////
    ~CCountries()
    {
        CPlayer *Current;    //The current node to delete
        CPlayer *Next;        //The next node to delete

        Current = Front;    //start Current in the front
        
        //Until the list is empty delete the nodes
        while(Current!=0)
        {
            Next = Current->Link;    //setup the next node
            delete Current;            //delete the current node
            Current = Next;            //prepare for the next loop run
        }
    }

    // This will let the player attack
    //////////////////////////////////
    bool Attack()
    {
        char Exit = 'Y';
        CPlayer *Victim;
        char VictimName[15];    // This will hold the victim's name
        bool Flag;                // True or flase value
        bool DeathFlag = FALSE;    // True or false value
        bool Win = FALSE;        

        while (toupper(Exit) == 'Y')
        {
            Victim = Front;
            Flag = FALSE;

            cout<<"What Player do you want to attack? ";
            cin>>VictimName;
            
            if ( strcmp(VictimName,Front->Name) == 0)
            {
                cout<<"If you want to fight your self be my guest!"<<endl;
            }

            Flag = FALSE;    // Start Flag at FALSE

            for(int Player = 0; Player < Total - 1; Player ++)
            {
                // Don't open a link = to 0.
                if (Victim->Link != 0) Victim = Victim->Link;
                else
                {
                    Flag = FALSE;
                    break;
                }

                if (strcmp(VictimName,Victim->Name) == 0)
                {
                    Flag = TRUE;
                    break;
                }

            }

            if (Flag == FALSE)
            {
                cout<<"No such player, Try again."<<endl;
                continue;    // This will go skip the rest of the loop and start again at the top
            }

            int AttackerArmies;    //This will hold the attacker's # of armies
            int VictimArmies;    //This will hold the Victim's # of armies
            char YorN = 'Y';

            while(toupper(YorN) == 'Y')
            {
                AttackerArmies = Front->Armies - 1 - (Victim->Armies * Victim->Technology / 5);
                VictimArmies = Victim->Armies - 1 - (Front->Armies * Front->Technology / 5);
                Front->Armies = AttackerArmies;
                Victim->Armies = VictimArmies;
                
                if(Victim->Armies < 1)
                {
                    Win = Dead(Victim);
                    End();
                    DeathFlag = TRUE;

                    if(Front->Armies > 1)
                    {
                        Front->Armies += AddArmies;
                        AddArmies *= 2;
                        cout<<Front->Name<<" you now have "<<Front->Armies<<" armies for your kill."
                            <<endl;
                        return (TRUE);
                    }
                    else
                    {
                        Win = Dead(Front);
                        End();
                        if(DeathFlag == FALSE)
                        {
                            Victim->Armies += AddArmies;
                            AddArmies *= 2;
                            cout<<Victim->Name<<" you now have "<<Victim->Armies<<" armies for your kill."
                                <<endl;
                        }
                        DeathFlag = TRUE;
                        return (FALSE);
                    }

                    DeathFlag = TRUE;
                    if (Win == TRUE) return (FALSE);
                }
                else if(Front->Armies < 1)
                {
                    Win = Dead(Front);
                    End();
                    if(DeathFlag == FALSE)
                    {
                        Victim->Armies += AddArmies;
                        AddArmies *= 2;
                        cout<<Victim->Name<<" you now have "<<Victim->Armies<<" armies for your kill."
                            <<endl;
                    }
                    DeathFlag = TRUE;
                    return (FALSE);
                }

                if(End() == TRUE) break;
                else if(DeathFlag == FALSE)
                {
                    Victim->CountryLoss();
                    Front->CountryLoss();
                    cout<<Front->Name<<" now has "<<Front->Armies<<" armies."<<endl;
                    cout<<Victim->Name<<" now has "<<Victim->Armies<<" armies."<<endl;
                    cout<<Front->Name<<", Would you like to attack again ((Y)es or (N)o)? ";
                    cin>>YorN;
                }
            }
            
            if(End() == FALSE)
            {
                cout<<"Would you like to attack another Player ((Y)es or (N)o)? ";
                cin>>Exit;
            }
            else break;
        }

        return (TRUE);    // Flag success
    }

    //Inserts a Player at the rear
    /////////////////////////////
    void Enqueue(CPlayer Player)
    {
        CPlayer *Ptr;            //Make a Ptr for the new node
        Ptr = new CPlayer;    // create a queuenode and point to it with Ptr
        
        *Ptr = Player;
        Ptr->Link = 0;            //start the pointer at 0
        Ptr->Previous = Rear;    //point to the previous player

        //If the node isn't empty set the last link to point to the new node
        if (Front != 0)
            Rear->Link = Ptr;
        //else make the Front point to it.
        else
            Front = Ptr;
        //Make the rear point to the new node
        Rear = Ptr;
    }

    //Delete the first player and return the data
    /////////////////////////////////////////////
    CPlayer Dequeue()
    {
        CPlayer Player;    //the return value
        CPlayer *Ptr;    //Will point to the first node

        //If there are nodes delete the first one
        if (Front != 0)
        {
            Ptr = Front;        //Have the Pointer aim at the Front
            Player = *Ptr;        //Copy the player
            Front = Ptr->Link;    //Make Front point to the next node in line
            delete Ptr;            //delete the node
            Front->Previous = 0;    // set to 0
            if (Front==0)        //If the list is empty make the rear point to 0
                Rear = 0;
        }
        //else print an error
        else
            cout<<"Hey man, there aren't any Players here!"<<endl;

        return (Player);    //Return the deleted Player
    }

    //return TRUE if the game is over
    ///////////////////////////////////
    bool End()
    {
        if(Rear == Front)
        {
            cout<<endl
                <<"\t"<<Front->Name<<" You are the Winner!!!!!"
                <<endl<<endl
                <<"Thanks for Playing and Good Bye."<<endl;
            exit(EXIT_SUCCESS);    // end program
        }
        else return (FALSE);
    }

private:

    // This will Delete a Player
    ////////////////////////////
    bool Dead(CPlayer *Victim)
    {
        CPlayer *Current;

        cout<<Victim->Name<<" you are dead!"<<endl;

        // Check to make sure is is not the first entry
        if(Victim->Previous != 0) 
        {
            Current = Victim->Previous;
            Current->Link = Victim->Link;
        }
        else    // else change the rear
        {
            Front = Victim->Link;
        }
        
        // Check to make sure it is not the last entry
        if(Victim->Link != 0)
        {
            Current = Victim->Link;
            Current->Previous = Victim->Previous;
        }
        else    // else change the Rear
        {
            Rear = Victim->Previous;
        }
        

        delete Victim;

        return (FALSE);
    }

    // This adds a player
    void AddPlayer(int Total)
    {
        CPlayer *Ptr;            //Make a Ptr for the new node
        Ptr = new CPlayer;    // create a queuenode and point to it with Ptr
        Ptr->Armies = 5;
        Ptr->Money = 5;
        Ptr->Territory = 5;
        Ptr->Technology = 1;
        Ptr->UpgradeCost = 5;
            
        cout<<"Player "<<Total<<" What is your name? ";
        cin>>Ptr->Name;

        Ptr->Link = 0;            //start the pointer at 0

        //If the node isn't empty, set the last link to point to the new node
        if (Front != 0)
        {
            Ptr->Previous = Rear;
            Rear->Link = Ptr;
        }
        //else make the Front point to it.
        else
        {
            Ptr->Previous = 0;
            Front = Ptr;
        }
        //Make the rear point to the new node
        Rear = Ptr;
    }


};

#endif
